########################################################################
# Pointwise - Proprietary software product of Pointwise, Inc.
#             Copyright (c) 1995-2012 Pointwise, Inc.
#             All rights reserved.
#
# module.mk for src\plugins\CaeUnsXML plugin
########################################################################

########################################################################
########################################################################
#
#                   DO NOT EDIT THIS FILE
#
# To simplify SDK upgrades, the standard module.mk file should NOT be edited.
#
# If you want to modify a plugin's build process, you should rename
# modulelocal-sample.mk to modulelocal.mk and edit its settings.
#
# See the comments in modulelocal-sample.mk for more information.
#
#                   DO NOT EDIT THIS FILE
#
########################################################################
########################################################################

CaeUnsXML_LOC := $(PLUGINS_LOC)/CaeUnsXML
CaeUnsXML_LIB := CaeUnsXML$(DBG_SUFFIX)
CaeUnsXML_CXX_LOC := $(CaeUnsXML_LOC)
CaeUnsXML_OBJ_LOC := $(PLUGINS_OBJ_LOC)/CaeUnsXML

CaeUnsXML_FULLNAME := lib$(CaeUnsXML_LIB).$(SHLIB_SUFFIX)
CaeUnsXML_FULLLIB := $(PLUGINS_DIST_DIR)/$(CaeUnsXML_FULLNAME)

CaeUnsXML_DEPS = \
	$(NULL)

MODCXXFILES := \
	runtimeWrite.c \
	$(NULL)

# IMPORTANT:
# Must recompile the shared/XXX/.c files for each plugin. These .c files
# include the plugin specific settings defined in the ./CaeUnsXML/*.h
# files.
CaeUnsXML_SRC := \
	$(PLUGINS_RT_PWPSRC) \
	$(PLUGINS_RT_PWGMSRC) \
	$(PLUGINS_RT_CAEPSRC) \
	$(patsubst %,$(CaeUnsXML_CXX_LOC)/%,$(MODCXXFILES))

CaeUnsXML_SRC_C := $(filter %.c,$(MODCXXFILES))
CaeUnsXML_SRC_CXX := $(filter %.cxx,$(MODCXXFILES))

# place the .o files generated from shared sources in the plugin's
# OBJ folder.
CaeUnsXML_OBJ := \
	$(patsubst %.c,$(CaeUnsXML_OBJ_LOC)/%.o,$(PLUGINS_RT_PWPFILES)) \
	$(patsubst %.c,$(CaeUnsXML_OBJ_LOC)/%.o,$(PLUGINS_RT_PWGMFILES)) \
	$(patsubst %.c,$(CaeUnsXML_OBJ_LOC)/%.o,$(PLUGINS_RT_CAEPFILES)) \
    $(patsubst %.c,$(CaeUnsXML_OBJ_LOC)/%.o,$(CaeUnsXML_SRC_C)) \
    $(patsubst %.cxx,$(CaeUnsXML_OBJ_LOC)/%.o,$(CaeUnsXML_SRC_CXX)) \
	$(NULL)

# To allow over-rides, search FIRST for headers in the local module's folder.
# For example, a site.h file in the local module's folder will preempt the
# file .../src/plugins/site.h
CaeUnsXML_INCL = \
	-I$(CaeUnsXML_LOC) \
	$(PLUGINS_RT_INCL) \
	$(NULL)

CaeUnsXML_LIBS = \
	$(NULL)

CaeUnsXML_MAINT_TARGETS := \
    CaeUnsXML_info \
    CaeUnsXML_install \
    CaeUnsXML_installnow \
    CaeUnsXML_uninstall


########################################################################
# Get (OPTIONAL) locally defined make targets. If a plugin developer wants
# to extend a plugin's make scheme, they should create a modulelocal.mk file
# in the plugin's base folder. To provide for future SDK upgrades, the standard
# module.mk file should NOT be directly edited.
#
ifneq ($(wildcard $(CaeUnsXML_LOC)/modulelocal.mk),)
    CaeUnsXML_DEPS += $(CaeUnsXML_LOC)/modulelocal.mk
    include $(CaeUnsXML_LOC)/modulelocal.mk
endif


# merge in plugin private settings

CaeUnsXML_OBJ += \
    $(patsubst %.c,$(CaeUnsXML_OBJ_LOC)/%.o,$(filter %.c,$(CaeUnsXML_CXXFILES_PRIVATE))) \
    $(patsubst %.cxx,$(CaeUnsXML_OBJ_LOC)/%.o,$(filter %.cxx,$(CaeUnsXML_CXXFILES_PRIVATE))) \
	$(NULL)

CaeUnsXML_SRC += \
	$(patsubst %,$(CaeUnsXML_CXX_LOC)/%,$(CaeUnsXML_CXXFILES_PRIVATE)) \
	$(NULL)

CaeUnsXML_INCL += $(CaeUnsXML_INCL_PRIVATE)
CaeUnsXML_LIBS += $(CaeUnsXML_LIBS_PRIVATE)
CaeUnsXML_CXXFLAGS += $(CaeUnsXML_CXXFLAGS_PRIVATE)
CaeUnsXML_LDFLAGS += $(CaeUnsXML_LDFLAGS_PRIVATE)
CaeUnsXML_MAINT_TARGETS += $(CaeUnsXML_MAINT_TARGETS_PRIVATE)

PLUGIN_MAINT_TARGETS += $(CaeUnsXML_MAINT_TARGETS)
PLUGIN_OBJ += $(CaeUnsXML_OBJ)

# add to plugin maint targets to the global .PHONY target
.PHONY: \
	$(CaeUnsXML_MAINT_TARGETS) \
	$(NULL)


########################################################################
# Set the final build macros
CaeUnsXML_CXXFLAGS := $(CXXFLAGS) $(PLUGINS_STDDEFS) $(CaeUnsXML_INCL) -DPWGM_HIDE_STRUCTURED_API

ifeq ($(machine),macosx)
CaeUnsXML_LDFLAGS = -install_name "$(REL_BIN_TO_PW_LIB_DIR)/$(CaeUnsXML_FULLNAME)"
else
CaeUnsXML_LDFLAGS =
endif


########################################################################
# list of plugin's build targets
#
CaeUnsXML: $(CaeUnsXML_FULLLIB)

$(CaeUnsXML_FULLLIB): $(CaeUnsXML_OBJ) $(CaeUnsXML_DEPS)
	@echo "***"
	@echo "*** $@"
	@echo "***"
	@mkdir -p $(PLUGINS_DIST_DIR)
	$(SHLIB_LD) $(ARCH_FLAGS) $(CaeUnsXML_LDFLAGS) -o $(CaeUnsXML_FULLLIB) $(CaeUnsXML_OBJ) $(CaeUnsXML_LIBS) $(SYS_LIBS)

CaeUnsXML_info:
	@echo ""
	@echo "--------------------------------------------------------------"
ifeq ($(machine),macosx)
	otool -L -arch all $(CaeUnsXML_FULLLIB)
	@echo ""
endif
	file $(CaeUnsXML_FULLLIB)
	@echo "--------------------------------------------------------------"
	@echo ""


########################################################################
# list of plugin's intermediate targets
#
$(CaeUnsXML_OBJ_LOC):
	mkdir -p $(CaeUnsXML_OBJ_LOC)

#.......................................................................
# build .d files for the plugin and each of the shared runtime sources
# the .d files will be placed in the plugins OBJ folder CaeUnsXML_OBJ_LOC
$(CaeUnsXML_OBJ_LOC)/%.d: $(CaeUnsXML_CXX_LOC)/%.c
	@echo "Updating dependencies $(CaeUnsXML_OBJ_LOC)/$*.d"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	@./depend.sh $(CaeUnsXML_OBJ_LOC) $(CaeUnsXML_CXXFLAGS) $< > $@

$(CaeUnsXML_OBJ_LOC)/%.d: $(PLUGINS_RT_PWPLOC)/%.c
	@echo "Updating dependencies $(CaeUnsXML_OBJ_LOC)/$*.d"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	@./depend.sh $(CaeUnsXML_OBJ_LOC) $(CaeUnsXML_CXXFLAGS) $< > $@

$(CaeUnsXML_OBJ_LOC)/%.d: $(PLUGINS_RT_PWGMLOC)/%.c
	@echo "Updating dependencies $(CaeUnsXML_OBJ_LOC)/$*.d"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	@./depend.sh $(CaeUnsXML_OBJ_LOC) $(CaeUnsXML_CXXFLAGS) $< > $@

$(CaeUnsXML_OBJ_LOC)/%.d: $(PLUGINS_RT_CAEPLOC)/%.c
	@echo "Updating dependencies $(CaeUnsXML_OBJ_LOC)/$*.d"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	@./depend.sh $(CaeUnsXML_OBJ_LOC) $(CaeUnsXML_CXXFLAGS) $< > $@

#.......................................................................
# build .o files for the plugin and each of the shared runtime sources.
# the .o files will be placed in the plugins OBJ folder CaeUnsXML_OBJ_LOC
$(CaeUnsXML_OBJ_LOC)/%.o: $(CaeUnsXML_CXX_LOC)/%.c
	@echo "***"
	@echo "*** $*"
	@echo "***"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	$(CXX) $(CaeUnsXML_CXXFLAGS) $(ARCH_FLAGS) -o $@ -c $<

$(CaeUnsXML_OBJ_LOC)/%.o: $(PLUGINS_RT_PWPLOC)/%.c
	@echo "***"
	@echo "*** $*"
	@echo "***"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	$(CXX) $(CaeUnsXML_CXXFLAGS) $(ARCH_FLAGS) -o $@ -c $<

$(CaeUnsXML_OBJ_LOC)/%.o: $(PLUGINS_RT_PWGMLOC)/%.c
	@echo "***"
	@echo "*** $*"
	@echo "***"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	$(CXX) $(CaeUnsXML_CXXFLAGS) $(ARCH_FLAGS) -o $@ -c $<

$(CaeUnsXML_OBJ_LOC)/%.o: $(PLUGINS_RT_CAEPLOC)/%.c
	@echo "***"
	@echo "*** $*"
	@echo "***"
	@mkdir -p $(CaeUnsXML_OBJ_LOC)
	$(CXX) $(CaeUnsXML_CXXFLAGS) $(ARCH_FLAGS) -o $@ -c $<


########################################################################
# list of plugin's clean targets
#
CaeUnsXML_cleandep:
	-$(RMR) $(CaeUnsXML_OBJ_LOC)/*.d

CaeUnsXML_clean:
	-$(RMR) $(CaeUnsXML_OBJ_LOC)/*.{d,o}

CaeUnsXML_distclean: CaeUnsXML_clean
	-$(RMF) $(CaeUnsXML_FULLLIB) > /dev/null 2>&1

########################################################################
# list of plugin's clean targets
#
CaeUnsXML_install: install_validate CaeUnsXML_installnow
	@echo "CaeUnsXML Installed to '$(PLUGIN_INSTALL_FULLPATH)'"

CaeUnsXML_installnow:
	-@$(CP) $(CaeUnsXML_FULLLIB) "$(PLUGIN_INSTALL_FULLPATH)/libCaeUnsXML.$(SHLIB_SUFFIX)"

CaeUnsXML_uninstall:
	@echo "CaeUnsXML Uninstalled from '$(PLUGIN_INSTALL_FULLPATH)'"
	-@$(RMF) "$(PLUGIN_INSTALL_FULLPATH)/libCaeUnsXML.$(SHLIB_SUFFIX)"
